<?php
// vuorovaikuta-evaste.php

// Tarvittavat muuttujat alustuksineen
$aika = time();
$action     = '';
$kokonimi   = '';
$osoite     = '';
$taustavari = '';
$hlotiedot  = '';

if (isset($_REQUEST['action'])) {
   $action = $_REQUEST['action'];
}

if (isset($_COOKIE['taustavari'])) {
   $taustavari = $_COOKIE['taustavari'];
}

if (isset($_COOKIE['kokonimi'])) {
   $kokonimi = $_COOKIE['kokonimi'];
}

if (isset($_COOKIE['osoite'])) {
   $osoite = $_COOKIE['osoite'];
}

switch ($action) {
   case "AsetaEvaste":
     header("Location: http://" . $_SERVER['HTTP_HOST']
                                . $_SERVER['PHP_SELF']
                                . "?action=$aika");
     setcookie("kokonimi", $_GET['kokonimi'] , time()+86400);
     setcookie("osoite", $_GET['osoite'] , time()+86400);
     setcookie("taustavari", $_GET['taustavari'] , time()+86400);
     break;
   case "PoistaEvaste":
     header("Location: http://" . $_SERVER['HTTP_HOST']
                                . $_SERVER['PHP_SELF']
                                . "?action=$aika");
     setcookie("kokonimi");
     setcookie("osoite");
     setcookie("taustavari");
}

// Tulostetaan varsinainen sivun sislt.
tulosta_sivun_alku($taustavari);
lomake($kokonimi, $osoite, $taustavari);
$hlotiedot  = muotoile_hlotiedot($kokonimi, $osoite);
echo $hlotiedot;

// Alkumuodollisuudet
function tulosta_sivun_alku($taustavari) {
    echo "<html><head>\n" .
         "<title>vuorovaikuta-evaste.php</title>" .
         "</head>\n" .
         "<body bgcolor='$taustavari'>\n" .
         "<a href='{$_SERVER['PHP_SELF']}?action=PoistaEvaste'>" .
         "Poista Evsteet</a><hr>\n";
}

//Syttlomake
function lomake($kokonimi, $osoite, $taustavari) {
?>
<form method="get"
        action="<?php echo $_SERVER['PHP_SELF'];?>">
Nimi:<br><input type="text" name="kokonimi" value="<?php
         echo (htmlspecialchars($kokonimi));?>"><br>
Osoite:<br><input type="text" name="osoite" value="<?php
         echo (htmlspecialchars($osoite));?>"><br>
Taustavri:<br>
<select name="taustavari" size="1">
<option value="">Valitse taustavari</option>
<option value="#ffff00"
<?php if ($taustavari == "#ffff00")echo "selected"?>>
Keltainen</option>
<option value="#ff0000"
<?php if ($taustavari == "#ff0000") echo "selected"?>>
Punainen</option>
<option value="#0000ff"
<?php if ($taustavari == "#0000ff") echo "selected"?>>
Sininen</option>
</select><p>
<input type="submit" name="painike"
       value="Lhet/Muuta tietosi">
<input type="hidden" name="action" value="AsetaEvaste">
</form>
<br>
<?php
}

function muotoile_hlotiedot($kokonimi, $osoite) {
   $html = "<hr>" .
           "Terve <strong>$kokonimi</strong><br>" .
           "Osoitteesi on <strong>$osoite</strong><p>" .
           "<hr>";
   return $html;
}

?>