<?php
// aut3.php

/******************Pohjelma******************************/

/* Jos kokeilet ohjelmaa Windows-jrjestelmss, kopioi tai
   kirjoita .htpasswd-tiedosto esim. nimell
   C:\salasanat\.htpasswd Tiedoston sisltn voi olla
   yksi rivi:

   arska:pLYLXWl25fzIc

   Kopioi rivi ylt haluamaasi tekstieditoriin, niin kryptatun
   salasanan merkit tulevat varmasti oikein.
   Tunnus/salasana-pari on siis arska/salasana.

    Tmn jlkeen vaihda $pwfile-muuttujan arvo 
    thn ohjelmaan seuraavaksi:
   $pwfile = "C:\\salasanat\\.htpasswd";

 */


$pwfile = "/home/ara/.htpasswd";
$erotin = ":";
$autentikoitu = FALSE;

if (isset($_SERVER['PHP_AUTH_USER']) AND 
    isset($_SERVER['PHP_AUTH_PW'])) {
   tarkista_autentikointi_info($pwfile, $erotin);
}

if (!$autentikoitu) {
   pyyda_autentikointi_info();
} else {
   echo "Tll voi tehd kaikkea salaista kivaa!";
}


/******************Funktiot********************************/

/* Palauttaa CSV- tai TSV-tiedoston moniulotteisessa
 * taulukossa */
function file_taulukkoon($filename, $erotin) {
   $taulu = file($filename);
   $rivilkm = count($taulu);
   for ( $i = 0; $i < $rivilkm; $i++) {
   	  //chop: rivinvaihto pois; 1-ul -> moniulotteinen
      $taulu[$i] = split($erotin, chop($taulu[$i]));
   }
   return $taulu;
}

function pyyda_autentikointi_info() { 
   header("WWW-Authenticate: Basic realm='Salattu alue'");
   header("HTTP/1.0 401 Unauthorized");
   echo "Teksti, jos kyttj valitsee Peruuta/Cancel\n";
   exit;
} 

function tarkista_autentikointi_info($pwfile, $erotin) { 
   global $autentikoitu;
   $kayttajat = file_taulukkoon($pwfile, $erotin);
   foreach ($kayttajat as $kayttaja) {	  
      $user = $kayttaja[0];
      $passwd = $kayttaja[1];
      if (strcmp($user, $_SERVER['PHP_AUTH_USER']) == 0) {
         // cryptin "suola" on merkeiss 1 ja 2
         $suola = substr($passwd, 0, 2);
         $crypt_passwd = crypt($_SERVER['PHP_AUTH_PW'], $suola);
         if (strcmp($crypt_passwd, $passwd) == 0) {
            $autentikoitu = TRUE;
            break;
         }
      }
   }
}

?>