<title>Ereg testing</title>
<?php
// ereg-testing.php

$malli   = '';
$mjono   = '';
$painike = '';

if (isset($_POST['painike'])) {
   $malli   = $_POST['malli'];
   $mjono   = $_POST['mjono'];
}

// Heitto- ja lainausmerkit pois tarvittaessa
if (ini_get('magic_quotes_gpc')) {
  $malli = stripslashes($malli);
  $mjono = stripslashes($mjono);
}

// Tulostamista varten
$hsc_malli = htmlspecialchars($malli);
$hsc_mjono = htmlspecialchars($mjono);

lomake($hsc_malli, $hsc_mjono);
tee_tulokset($hsc_malli, $hsc_mjono);

// Tulosten havainnollistaminen
function tee_tulokset($hsc_malli, $hsc_mjono) {
echo "<pre>\n";
$s_span = <<< EOSPAN
<span style="color:black;background-color:#ffff00">
EOSPAN;
$e_span = "</span>";

if (isset($_POST['painike'])) {
   echo "Malli (RE) : $hsc_malli\n";
   echo "Merkkijono : $hsc_mjono\n";
   if (ereg ($_POST['malli'], $_POST['mjono'], $regs)) {
      echo "<strong>Lytyi seuraava osuma:</strong>\n";
      echo "regs[0] = $s_span$regs[0]$e_span\n\n";
      echo "<strong>Sulkulausekkeet:</strong>\n";
      for ($i=1;$i<10;$i++) {
         if (isset($regs[$i])) {
            echo "regs[$i] = $s_span$regs[$i]$e_span<br>\n";
         }
      }
   } else {
      echo "<strong>Ei osumaa!</strong>\n";
   }
}
echo "</pre>\n";
}

// Syttlomake
function lomake($hsc_malli, $hsc_mjono) {
 echo "<form method='post' action='{$_SERVER['PHP_SELF']}'>\n" .
      "Malli (RE):<br>\n" .
      "<input type='text' name='malli' size='40' " .
      "value='$hsc_malli'>\n";

 echo "<br>" .
      "Tutkittava merkkijono:<br>\n";

 echo "<textarea name='mjono' rows='3' cols='40'>" .
      "$hsc_mjono</textarea>\n";

 echo "<input type='submit' name='painike' value='Tutki'>\n" .
      "</form>\n" .
      "<hr>\n";
}