<?php
// mysql-simple-v4.php

require_once('config.php');
require_once('dbopen.php');

// Rivien kokonaislukumr henkilot-taulussa
$rivilkm = dbtable_numrows("henkilot");

// Nytettvien rivien lkm yhdell HTML-sivulla
$riveja_per_sivu = 2;

// Nkyvill olevan HTML-sivun ensimmisen tietueen
// jrjestysnumero. Numerointi alkaa nollasta.
if(isset($_GET['alku'])) {
    $alku = $_GET['alku'];
} else {
    $alku  = 0;
}

// HTML:n tulostus:
do_header();
do_navbar($alku, $riveja_per_sivu, $rivilkm);
$result = hae_henkilot($alku, $riveja_per_sivu);
if ($result) {
   sql_tulokset_html_taulukkoon($result);
} else {
   echo "Virhe: Ei tulosrivej!";
}

require_once('dbclose.php');

/******************** Funktiot ********************/

// Lasketaan tietokannan taulun tietueiden lukumr
function dbtable_numrows($taulu) {
   $query = "SELECT count(*) AS lkm FROM $taulu";
   $result= mysql_query($query)
       or die("Kyselyss tapahtui virhe.: " . mysql_error());
   $row = mysql_fetch_array($result);
   $rows= $row['lkm'];
   return $rows;
}

function hae_henkilot($alku, $riveja_per_sivu) {
   $query  = "SELECT sukunimi, etunimi, email, puhnro ";
   $query .= "FROM henkilot LIMIT $alku, $riveja_per_sivu";

   $result= mysql_query($query)
       or die("Kyselyss tapahtui virhe.: " . mysql_error());
   $rows = mysql_num_rows($result);
   if ($rows == 0) $result = FALSE;
   return $result;
}

// SQL-kyselyn tulosjoukko HTML-taulukkoon.
function sql_tulokset_html_taulukkoon($result) {
   /* Kyselyn tuloksen rivien ja sarakkeiden lkm
    */
   $rows  = mysql_num_rows($result);
   $cols  = mysql_num_fields($result);
   echo "<table border='1'>\n";

   /* Tulostetaan otsikot ensimmiselle riville 
    * mysql_fiel_dname hakee kentn (sarakkeen)  i+1 nimen 
    * %s tarkoittaa muotoilua ~ tulosta merkkijonona
    */

   echo "<tr bgcolor='#ffeedd'>\n";  
   for($i = 0;  $i < $cols; $i++) {  
      printf("<td>%s</td>\n",
      mysql_field_name($result, $i));
   }  
   echo "</tr>\n";     

   /* Kydn tulosjoukon kaikki rivit ja sarakkeet lpi 
    * mysql_result hakee $j:n ja $i:n mrmn tietueen
    * kentn arvon
    */ 

   for($j = 0; $j < $rows; $j++) {
      echo "<tr>\n";
      for($i = 0; $i < $cols; $i++) {
         printf("<td>%s</td>\n",
         mysql_result($result,$j,$i));
      }  
      echo "</tr>\n";  
   }
   echo "</table>\n";
}

// [Edellinen] [Seuraava] -navigointivalikon tulostaminen 
function do_navbar($alku, $riveja_per_sivu, $rivilkm) {
   
   $real_start = $alku +1;
   $real_end = $real_start + $riveja_per_sivu - 1;
   echo "Tietueet <b>$real_start - $real_end</b>" . 
        " [Yhteens <b>$rivilkm</b> tietuetta]<br>\n";

   if($alku > 0) {
      $ed = $alku - $riveja_per_sivu;
      echo "[ <a href='{$_SERVER['PHP_SELF']}?" .
           "alku=$ed'>Edellinen</a> ]\n";
   } else {
      echo "[ Edellinen ]\n";
   }
   if (($alku + $riveja_per_sivu) < $rivilkm) {
      $seur = $alku + $riveja_per_sivu;
      echo "[ <a href='{$_SERVER['PHP_SELF']}?" .
           "alku=$seur'>Seuraava</a> ]\n";
   } else {
      echo "[ Seuraava ]\n";
   }
}

// Alkumuodollisuudet
function do_header() {
   $title = "Selaa osoitteet-tietokantaa";
   echo "<head>\n";
   echo "<title>$title</title>\n";
   echo "</head>\n";
   echo "<h3>$title</h3>\n";
   echo "<hr>\n";
}

?>